/**
 * generated by Xtext 2.32.0
 */
package no.ntnu.tdt4250.sm.textual.generator;

import no.ntnu.tdt4250.sm.StateMachine;
import no.ntnu.tdt4250.sm.genjavaxtend.StateMachineGenerator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class StateMachineDSLGenerator extends AbstractGenerator {
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    EObject _get = resource.getContents().get(0);
    final StateMachine sm = ((StateMachine) _get);
    final StateMachineGenerator generator = new StateMachineGenerator(sm);
    StringConcatenation _builder = new StringConcatenation();
    String _name = sm.getName();
    _builder.append(_name);
    _builder.append(".java");
    fsa.generateFile(_builder.toString(), 
      generator.generateMachine());
    StringConcatenation _builder_1 = new StringConcatenation();
    _builder_1.append("MachineState.java");
    fsa.generateFile(_builder_1.toString(), 
      generator.generateMachineStates());
  }
}
